'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.post = post;

var _request = require('../request');

var _restler = require('restler');

var _restler2 = _interopRequireDefault(_restler);

var _js2xml = require('js2xml');

var _options = require('../options');

var _options2 = _interopRequireDefault(_options);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var opt = Object.create(_options2.default);

/**
 * POST request
 *
 * @param {Object} conn
 * @param {string} conn.id Required, app id
 * @param {string} conn.token Required, token to access shop
 * @param {string} conn.url Required, shop url
 * @param {string} conn.api Required, api endpoint
 * @param {object} [conn.obj] HTTP POST data
 * @returns {Promise}
 */
function post(conn) {
  if (conn.obj !== undefined) {
    var js2xml = new _js2xml.Js2Xml(Object.keys(conn.obj)[0], conn.obj[Object.keys(conn.obj)[0]]);
    opt.data = js2xml.toString();
  }

  var p = _restler2.default.post('https://' + conn.id + ':' + conn.token + '@' + conn.url + '/admin/' + conn.api + '.xml', opt);
  return new Promise(function (resolve, reject) {
    (0, _request.request)(p).then(resolve).catch(reject);
  });
}